defmodule ExDataGovUA.Fetchers.FinchFetcher do
  @behaviour ExDataGovUA.Fetchers.Base

  @impl true
  def fetch(method, url) do
    start()
    with request <- Finch.build(method, url),
         {:ok, %Finch.Response{body: body}} <- Finch.request(request, MyFinchFetcher) do
      {:ok, body}
    end
  end

  defp start() do
    case Finch.start_link(name: MyFinchFetcher) do
      {:ok, pid} -> pid
      {:error, {:already_started, pid}} -> pid
    end
  end
end
